        @PUSH           <ESI, EDI>

;        jmp             err_1587

        MOVZX           ECX, CX
        CMP             ECX, 8000H
        JA              ERR_1587

        MOVZX           EBX, WORD PTR SS:[EBP+6*4]      ; ES
        SHL             EBX, 4
        MOVZX           ESI, SI
        ADD             EBX, ESI                        ; EBX=ES*16+SI

        MOV             ESI, ES:[EBX+10H+2]             ; 24-BIT SOURCE
        AND             ESI, 0FFFFFFH
        MOVZX           EAX, BYTE PTR ES:[EBX+10H+7]
        SHL             EAX, 24
        ADD             ESI, EAX
        MOV             EDI, ES:[EBX+18H+2]             ; 24-BIT DESTINATION
        AND             EDI, 0FFFFFFH
        MOVZX           EAX, BYTE PTR ES:[EBX+18H+7]
        SHL             EAX, 24
        ADD             EDI, EAX

        MOV             BX, FLAT_SEL
        MOV             DS, BX
        CLD
        REP             MOVSW
        MOV             BX, DS_SEL
        MOV             DS, BX

        MOV             BYTE PTR SS:[ESP+5*4+1], 0      ; AH=0 - NO ERROR
        AND             BYTE PTR SS:[EBP+3*4], NOT 1    ; CF=0 - NO ERROR
        JMP             EXIT_1587
ERR_1587:
        MOV             BYTE PTR SS:[ESP+5*4+1], 3      ; AH=3 - ERROR
        OR              BYTE PTR SS:[EBP+3*4], 1        ; CF=1 - ERROR

EXIT_1587:
        @POP            <EDI, ESI>
