;-----------;
; Fills IDT ;
;-----------;

; EXCEPTIONS GO HERE

IRPC            N, 0123456789ABCDEF                     ; 00...0F
        LEA     EAX, EXC_0&N
        MOV     IDT_0&N.OFFS_L, AX
        SHR     EAX, 16
        MOV     IDT_0&N.OFFS_H, AX
ENDM
IRPC            N, 0123456789ABCDEF                     ; 10...1F
        LEA     EAX, EXC_1&N
        MOV     IDT_1&N.OFFS_L, AX
        SHR     EAX, 16
        MOV     IDT_1&N.OFFS_H, AX
ENDM

; IRQs GO HERE

IRPC            N, 0123456789ABCDEF                     ; 20...2F
        LEA     EAX, IRQ_0&N
        MOV     IDT_IRQ_0&N.OFFS_L, AX
        SHR     EAX, 16
        MOV     IDT_IRQ_0&N.OFFS_H, AX
ENDM

; INTs GO HERE

        LEA     EAX, SERVICE_INTERRUPT                  ; 30
        MOV     IDT_SERVICE.OFFS_L, AX
        SHR     EAX, 16
        MOV     IDT_SERVICE.OFFS_H, AX
