;----------------------------------;
; Timer hardware interrupt handler ;
;----------------------------------;

TIMER_HANDLER PROC NEAR
        @PUSH   <DS, ES>
        PUSHAD
        MOV     AX, DS_SEL
        MOV     DS, AX
        MOV     AX, BIOS_SEL
        MOV     ES, AX

;        INC     DWORD PTR ES:[06CH]             ; UPDATE BIOS TICK COUNTER

        MOV     AX, DS:[TIMER_CNT]              ; INTERNAL TICK COUNTER
        INC     AX
        CMP     AX, 9                           ; IS TIME FOR "*" OR " "?
        JNE     @@TIMER_END                     ; NO, IT ISN'T

        MOV     AX, TEXT_SEL
        MOV     ES, AX
        MOV     AL, ES:[2*79]
        MOV     BYTE PTR ES:[2*79], 0           ; " " <-> "*"
        CMP     AL, '*'
        JE      @@TIMER_FLAG
        MOV     BYTE PTR ES:[2*79], '*'         ; "*" <-> " "

@@TIMER_FLAG:
        XOR     AX, AX
@@TIMER_END:                                    ; UPDATE INTERNAL TICK COUNTER
        MOV     DS:[TIMER_CNT], AX

        POPAD
        @POP    <ES, DS>
        RET
TIMER_HANDLER ENDP
