;--------------------------------;
; Launches a command interpreter ;
;--------------------------------;

LCOMMAND PROC NEAR
        MOV             AX, DATA
        MOV             DS, AX
	MOV		AH, 51H
	INT		21H
	MOV		ES, BX
	MOV		ES, ES:[02CH]		;ENVIRONMENT'S SEGMENT
	XOR		DI, DI
	LEA		SI, COMSPEC
	CLD
	MOV		DX, 32000		;MAX SIZE OF ENVIRONMENT
LCOMMAND_FIND_COM:
	PUSH		SI
	PUSH		DI
	MOV		CX, 8
	REPE CMPSB
	JE		LCOMMAND_FOUND_COM
	POP		DI
	POP		SI
	INC		DI
	DEC		DX
	JNZ		LCOMMAND_FIND_COM
	JMP		LCOMMAND_NOTFOUND_COM
LCOMMAND_FOUND_COM:
	POP		SI
	POP		SI
	PUSH		ES
	POP		DS
	MOV		SI, DI
        MOV             AX, DATA
        MOV             ES, AX
	LEA		DI, COMNAME
LCOMMAND_FILL_COM:
	LODSB
	STOSB
	OR		AL, AL
	JZ		LCOMMAND_FILL_END
	JMP		LCOMMAND_FILL_COM
LCOMMAND_FILL_END:

	MOV		AH, 02FH
	INT		021H
        MOV             AX, DATA
        MOV             DS, AX
	MOV		DS:DTA_OFS, BX
	MOV		DS:DTA_SEG, ES		;GET DTA

	MOV		DS:KEEP_SP, SP
	MOV		DS:KEEP_SS, SS

	MOV		AX, DS
	MOV		ES, AX
	LEA		DX, COMNAME
	LEA		BX, R_EXEC
	MOV		AX, 04B00H
	INT		021H

        MOV             AX, DATA
        MOV             DS, AX
        MOV             ES, AX

	CLI
	MOV		SP, DS:KEEP_SP
	MOV		SS, DS:KEEP_SS
	STI

	MOV		AH, 01AH
	MOV		DX, DS:DTA_OFS
	MOV		DS, DS:DTA_SEG
	INT		021H			;SET DTA

LCOMMAND_NOTFOUND_COM:

        MOV             AX, DATA
        MOV             DS, AX
        MOV             ES, AX
        RET
LCOMMAND ENDP
